//+------------------------------------------------------------------+
//|                                    Copyright 2018 YutakaYokouchi |
//|                           https://www.mql5.com/en/users/abundant |
//+------------------------------------------------------------------+
//| Constants and enumeration for migration                          |
//+------------------------------------------------------------------+
#define EMPTY -1
//+------------------------------------------------------------------+
//|                                               Converted by BRiCK |
//|                           https://www.mql5.com/en/users/abundant |
//+------------------------------------------------------------------+


﻿//+------------------------------------------------------------------+
//| СПЕЦИФИЧЕСКИЕ ПАРАМЕТРЫ
//+------------------------------------------------------------------+
#property copyright "";          //Авторство
#property link "";               //Сылка на сайт разработчика
#property version "";            //Версия индикатора
#property description "";        //Описание индикатора
#property strict                 //Строгий режим компиляции
#property indicator_chart_window //Вывод индикатора в окне графика
#property indicator_buffers 2    //Количество буферов для расчетов индикатора
//+------------------------------------------------------------------+
//| СПЕЦИФИЧЕСКИЕ ПАРАМЕТРЫ
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
//| ВХОДНЫЕ НАСТРОЙКИ
//+------------------------------------------------------------------+
extern ENUM_TIMEFRAMES TimeFrame = PERIOD_CURRENT; //Таймфрейм для построения облаков
extern color           SellZone  = clrLightSalmon; //Цвет облака на продажу
extern color           BuyZone   = clrDeepSkyBlue; //Цвет облака на покупку
extern int             OverSize  = 1;              //Толщина линий в облаке
extern int             History   = 750;            //Ограничение истории в барах
//+------------------------------------------------------------------+
//| ВХОДНЫЕ НАСТРОЙКИ
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
//| ВНУТРЕННИЕ ГЛОБАЛЬНЫЕ ПЕРЕМЕННЫЕ
//+------------------------------------------------------------------+
double sellZone[];
double buyZone[];
double fastUpp[];
double fastMid[];
double fastLow[];
double slowUpp[];
double slowMid[];
double slowLow[];
//+------------------------------------------------------------------+
//| ВНУТРЕННИЕ ГЛОБАЛЬНЫЕ ПЕРЕМЕННЫЕ
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
//| ПЕРВОНАЧАЛЬНАЯ ИНИЦИАЛИЗАЦИЯ
//+------------------------------------------------------------------+
int OnInit()
  {
   BRiCK();

   //Страхуемся от показа расчетов с меньшего таймфрейма
   if(TimeFrame <= _Period) TimeFrame = (ENUM_TIMEFRAMES)_Period;
   //Инициализация и настройка индикаторных буферов
   IndicatorBuffers(8);
   SetIndexBuffer(0, sellZone);
   SetIndexBuffer(1, buyZone);
   SetIndexBuffer(2, fastUpp);
   SetIndexBuffer(3, fastMid);
   SetIndexBuffer(4, fastLow);
   SetIndexBuffer(5, slowUpp);
   SetIndexBuffer(6, slowMid);
   SetIndexBuffer(7, slowLow);
   SetIndexStyle(0, DRAW_HISTOGRAM, 0, OverSize, SellZone);
   SetIndexStyle(1, DRAW_HISTOGRAM, 0, OverSize, BuyZone);
   SetIndexLabel(0, "sellZone");
   SetIndexLabel(1, "buyZone");

   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| ПЕРВОНАЧАЛЬНАЯ ИНИЦИАЛИЗАЦИЯ
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
//| ТЕЛО ИНДИКАТОРА
//+------------------------------------------------------------------+
int OnCalculate(const int        rates_total,     //Количество баров на текущем тике
                const int        prev_calculated, //Количество закрытых баров 
                const datetime   &time[],         //Массив времени каждого бара в истории
                const double     &open[],         //Массив цен открытия каждого бара в истории
                const double     &high[],         //Массив максимумов каждого бара в истории
                const double     &low[],          //Массив минимумов каждого бара в истории
                const double     &close[],        //Массив цен закрытия каждого бара в истории
                const long       &tick_volume[],  //Массив объема в тиках каждого бара в истории
                const long       &volume[],       //Массив реального объема каждого бара в истории
                const int        &spread[])       //Массив спреда каждого бара в истории
  {
   BRiCK();

   //Объявление внутренних переменных
   int i, limit;
   //Определение стартового бара для расчета
   if(History == 0 || prev_calculated >= History) limit = MathMin(rates_total - 1, rates_total - prev_calculated);
   else limit = History;
   //Цикл расчета индикатора
   for(i = limit; i >= 0; i--)
     {
      fastMid[i] = iMA(NULL,TimeFrame,22,0,3,0,iBarShift(NULL,TimeFrame,Time[i],false));
      fastUpp[i] = (1.3 * iATR(NULL,TimeFrame,999,(iBarShift(NULL,TimeFrame,Time[i], false) + 1))) + fastMid[i];
      fastLow[i] = fastMid[i] - (1.3 * iATR(NULL,TimeFrame,999,(iBarShift(NULL,TimeFrame,Time[i], false) + 1)));
      slowMid[i] = iMA(NULL,TimeFrame,233,0,3,0,iBarShift(NULL,TimeFrame,Time[i],false));
      slowUpp[i] = (4 * iATR(NULL,TimeFrame,999,(iBarShift(NULL,TimeFrame,Time[i], false) + 1))) + slowMid[i];
      slowLow[i] = slowMid[i] - (4 * iATR(NULL,TimeFrame,999,(iBarShift(NULL,TimeFrame,Time[i], false) + 1)));
      if(SellZone != clrNONE && fastUpp[i] > slowUpp[i])
        {
         sellZone[i] = fastUpp[i];
         buyZone[i] = slowUpp[i];
        }
      if(BuyZone != clrNONE && fastLow[i] < slowLow[i])
        {
         buyZone[i] = slowLow[i];
         sellZone[i] = fastLow[i];
        }
     }
   return(rates_total);
  }
//+------------------------------------------------------------------+
//| ТЕЛО ИНДИКАТОРА
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//|                                    Copyright 2018 YutakaYokouchi |
//|                           https://www.mql5.com/en/users/abundant |
//+------------------------------------------------------------------+
//| Functions for migration                                          |
//+------------------------------------------------------------------+
double Ask=0;
int Bars=0;
double Bid=0;
int Digits=0;
double Point=0;
double Close[];
double High[];
double Low[];
double Open[];
datetime Time[];
long Volume[];
void BRiCK()
{
   Ask=SymbolInfoDouble(_Symbol,SYMBOL_ASK);
   Bars=Bars(_Symbol, _Period);
   Bid=SymbolInfoDouble(_Symbol,SYMBOL_BID);
   Digits=(int)SymbolInfoInteger(_Symbol,SYMBOL_DIGITS);
   Point=SymbolInfoDouble(_Symbol,SYMBOL_POINT);

   ArraySetAsSeries(Close, true);
   ArraySetAsSeries(High, true);
   ArraySetAsSeries(Low, true);
   ArraySetAsSeries(Open, true);
   ArraySetAsSeries(Time, true);
   ArraySetAsSeries(Volume, true);

   int count = Bars(_Symbol, _Period);

   ArrayResize(Close, count);
   ArrayResize(High, count);
   ArrayResize(Low, count);
   ArrayResize(Open, count);
   ArrayResize(Time, count);
   ArrayResize(Volume, count);

   CopyClose(_Symbol, _Period, 0, Bars, Close);
   CopyHigh(_Symbol, _Period, 0, Bars, High);
   CopyLow(_Symbol, _Period, 0, Bars, Low);
   CopyOpen(_Symbol, _Period, 0, Bars, Open);
   CopyTime(_Symbol, _Period, 0, Bars, Time);
   CopyTickVolume(_Symbol, _Period, 0, Bars, Volume);
}


void SetIndexLabel(int index, string text)
{
  return;
}
void SetIndexStyle(int index, int type, int style=EMPTY, int width=EMPTY, color clr=clrNONE)
{
  return;
}
bool SetIndexBuffer(int index, double &buffer[])
{
  return(false);
}
bool IndicatorBuffers(int count)
{
  return(false);
}
double iATR(string symbol,int timeframe,int period,int shift)
{
  return(0);
}

double iMA(string symbol,int timeframe,int period,int ma_shift,int method,int price,int shift)
{
  return(0);
}

int iBarShift(string symbol, int timeframe, datetime time, bool exact=true)
{
  return(iBarShift(symbol, IntegerToTimeframe(timeframe), time, exact));
}

ENUM_TIMEFRAMES IntegerToTimeframe(int value){
   switch(value){
      case 1:
         return(PERIOD_M1);
      case 2:
         return(PERIOD_M2);
      case 3:
         return(PERIOD_M3);
      case 4:
         return(PERIOD_M4);
      case 5:
         return(PERIOD_M5);
      case 6:
         return(PERIOD_M6);
      case 10:
         return(PERIOD_M10);
      case 12:
         return(PERIOD_M12);
      case 15:
         return(PERIOD_M15);
      case 20:
         return(PERIOD_M20);
      case 30:
         return(PERIOD_M30);
      case 60:
         return(PERIOD_H1);
      case 120:
         return(PERIOD_H2);
      case 180:
         return(PERIOD_H3);
      case 240:
         return(PERIOD_H4);
      case 360:
         return(PERIOD_H6);
      case 480:
         return(PERIOD_H8);
      case 720:
         return(PERIOD_H12);
      case 1440:
         return(PERIOD_D1);
      case 10080:
         return(PERIOD_W1);
      case 43200:
         return(PERIOD_MN1);
      default:
         return(PERIOD_CURRENT);
   }
}
//+------------------------------------------------------------------+
//|                                               Converted by BRiCK |
//|                           https://www.mql5.com/en/users/abundant |
//+------------------------------------------------------------------+